## cpputest 3.1

=== Makefile ===
#Set this to @ to keep the makefile quiet
SILENCE = @

#--- Inputs ----#
COMPONENT_NAME = CppUTest
ifeq ($(CPPUTEST_USE_STD_C_LIB), N)
	CPP_PLATFORM = GccNoStdC
else
	CPP_PLATFORM = Gcc
endif
CPPUTEST_HOME = .
OLD_MAKE = oldmake

CPPUTEST_ENABLE_DEBUG = Y

SRC_DIRS = \
	src/CppUTest \
	src/Platforms/$(CPP_PLATFORM)
	
TEST_SRC_DIRS = \
	tests

INCLUDE_DIRS =\
  include

include $(CPPUTEST_HOME)/build/MakefileWorker.mk

#these are a sample of the other alternative flag settings
.PHONY: test_all
test_all: start test_old_make
	@echo Building with the default flags.
	make clean
	$(TIME) make 
	./$(TEST_TARGET) -r
	make clean
	@echo Building with the STDC++ new disabled. 
	$(TIME) make CPPUTEST_USE_STD_CPP_LIB=Y extensions 
	make CPPUTEST_USE_STD_CPP_LIB=Y cleanExtensions
	@echo Building with Memory Leak Detection disabled
	$(TIME) make CPPUTEST_USE_MEM_LEAK_DETECTION=N extensions
	make CPPUTEST_USE_MEM_LEAK_DETECTION=N cleanExtensions
	@echo Building with Memory Leak Detection disabled and STD C++ disabled
	$(TIME) make CPPUTEST_USE_MEM_LEAK_DETECTION=N CPPUTEST_USE_STD_CPP_LIB=Y extensions
	make CPPUTEST_USE_MEM_LEAK_DETECTION=N CPPUTEST_USE_STD_CPP_LIB=Y cleanExtensions
	@echo Building with debug disabled
	$(TIME) make CPPUTEST_ENABLE_DEBUG=N extensions
	make CPPUTEST_ENABLE_DEBUG=N cleanExtensions
	@echo Building with overridden CXXFLAGS and CFLAGS and CPPFLAGS
	$(TIME) make CLFAGS="" CXXFLAGS="" CPPFLAGS="-Iinclude"
	make CFLAGS="" CXXFLAGS="" clean
	@echo Building without Standard C library includes
	$(TIME) make CPPUTEST_USE_STD_C_LIB=N all_no_tests
	make CPPUTEST_USE_STD_C_LIB=N clean
	@echo Building with overridden CXXFLAGS and CFLAGS and memory leak and STDC++ disabled
	$(TIME) make CLFAGS="" CXXFLAGS="" CPPFLAGS="-Iinclude -DCPPUTEST_STD_CPP_LIB_DISABLED -DCPPUTEST_MEM_LEAK_DETECTION_DISABLED"
	make CFLAGS="" CXXFLAGS="" CPPFLAGS="-DCPPUTEST_STD_CPP_LIB_DISABLED -DCPPUTEST_MEM_LEAK_DETECTION_DISABLED" clean
	@echo Building CppUTest with Google Test 
	$(SILENCE) if [ -z $$GTEST_HOME ]; then  \
	   echo "******** WARNING: Can't test with CPPUTEST_USE_REAL_GTEST because can't find Google Test -- no GTEST_HOME set ********"; \
	   else $(TIME) make extensions CPPUTEST_USE_REAL_GTEST=Y; fi
	@echo Building CppUTest with Google Mock 
	$(SILENCE) if [ -z $$GMOCK_HOME ]; then  \
	   echo "******** WARNING: Can't test with CPPUTEST_USE_REAL_GMOCK because can't find Google Mock -- no GMOCK_HOME set ********"; \
	   else $(TIME) make extensions CPPUTEST_USE_REAL_GMOCK=Y; fi
	@echo Building examples 
	make cleanExamples
	$(TIME) make examples
	make cleanExamples
	@echo Testing JUnit output
	$(TIME) make
	$(SILENCE)./$(TEST_TARGET) -ojunit > junit_run_output
	$(SILENCE)if [ -s junit_run_output ]; then echo "JUnit run has output. Build failed!"; exit 1; fi
	make clean
	make CPPUTEST_MAP_FILE=map.txt
	make clean
	@echo Testing GCOV usage
	$(TIME) make CPPUTEST_USE_GCOV=Y everythingInstall
	make gcov
	make -f Makefile_CppUTestExt gcov
	make -C examples gcov
	make cleanEverythingInstall
	@echo Testing VPATH usage
	$(TIME) make CPPUTEST_USE_GCOV=Y CPPUTEST_USE_VPATH=Y everythingInstall
	make CPPUTEST_USE_VPATH=Y gcov
	make CPPUTEST_USE_VPATH=Y -f Makefile_CppUTestExt gcov
	make CPPUTEST_USE_VPATH=Y -C examples gcov	
	make clean
	@echo Testing VPATH usage
	$(TIME) make CPPUTEST_USE_VPATH=Y everythingInstall
	make CPPUTEST_USE_VPATH=Y cleanEverythingInstall
	make flags
	make debug
	
HAS_OLD_MAKE = $(shell $(OLD_MAKE) -v 2>/dev/null)

test_old_make:
	$(SILENCE)if [ "$(HAS_OLD_MAKE)" = "" ]; then \
		echo "Old make with the name $(OLD_MAKE) not found. Skipping testing with old make version"; \
	else \
		$(OLD_MAKE) -f Makefile_for_old_make clean && \
		$(OLD_MAKE) -f Makefile_for_old_make && \
		$(OLD_MAKE) -f Makefile_for_old_make extensions && \
		$(OLD_MAKE) -f Makefile_for_old_make clean; \
	fi

.PHONY: examples
examples: $(TEST_TARGET) extensions
	$(TIME) make -C examples  all CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)

extensions: $(TEST_TARGET)
	$(TIME) make -f Makefile_CppUTestExt all CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)

cleanExtensions: clean
	$(TIME) make -f Makefile_CppUTestExt clean CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)
	
cleanExamples: clean cleanExtensions
	$(TIME) make -C examples clean CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)

.PHONY: everythingInstall
everythingInstall: all extensions examples

.PHONY: cleanEverythingInstall
cleanEverythingInstall: clean cleanExtensions cleanExamples

=== debian/changelog ===
cpputest (3.1-2) unstable; urgency=low

  * Use override-*-indep targets in debian/rules when acting on files
    from an arch: all package. Closes: #676411

 -- Raphaël Hertzog <hertzog@debian.org>  Thu, 07 Jun 2012 08:22:10 +0200

cpputest (3.1-1) unstable; urgency=low

  * Initial release. Closes: #676166

 -- Raphaël Hertzog <hertzog@debian.org>  Tue, 05 Jun 2012 13:45:24 +0200

=== debian/control ===
Source: cpputest
Section: devel
Priority: optional
Maintainer: Raphaël Hertzog <hertzog@debian.org>
Homepage: http://www.cpputest.org
Vcs-Git: git://anonscm.debian.org/collab-maint/cpputest.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/cpputest.git
Standards-Version: 3.9.3
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~)

Package: cpputest
Architecture: all
Multi-Arch: foreign
Depends: libcpputest-dev, ${misc:Depends}
Suggests: ruby | ruby-interpreter
Description: C/C++ based unit test framework — main package
 CppUTest is a C/C++ based unit xUnit test framework for unit testing and
 for test-driving your code. It is written in C++ but is used in C and C++
 projects and frequently used in embedded systems.
 .
 CppUTest has a couple design principles:
  * Simple to use and small
  * Portable to old and new platforms
 .
 CppUTest also has support for building mocks and can be used by
 practitioners of Test Driven Development.
 .
 This is the main package. It contains some examples, support scripts
 and depends on libcpputest-dev which provides the test framework
 itself.

Package: libcpputest-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C/C++ based unit test framework — headers and static libraries
 CppUTest is a C/C++ based unit xUnit test framework for unit testing and
 for test-driving your code. It is written in C++ but is used in C and C++
 projects and frequently used in embedded systems.
 .
 CppUTest has a couple design principles:
  * Simple to use and small
  * Portable to old and new platforms
 .
 CppUTest also has support for building mocks and can be used by
 practitioners of Test Driven Development.
 .
 This is the package with the headers and the static libraries implementing
 the test framework.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_auto_build:
	$(MAKE) all extensions

override_dh_auto_install:
	mkdir -p debian/libcpputest-dev/usr/lib/$(DEB_HOST_MULTIARCH)
	cp lib/*.a debian/libcpputest-dev/usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_auto_clean:
	$(MAKE) cleanExtensions clean

override_dh_compress:
	dh_compress -X.cpp

# Fixes for the cpputest (arch-all) package
override_dh_installexamples-indep:
	dh_installexamples
	chmod 644 debian/cpputest/usr/share/doc/cpputest/examples/*.dsw

override_dh_fixperms-indep:
	chmod 755 debian/cpputest/usr/share/cpputest/scripts/NewProject.sh \
		  debian/cpputest/usr/share/cpputest/scripts/convertToUnity/create_unity_test_runner.rb
	dh_fixperms

# Work-around debhelper bug #676462
override_dh_installexamples-arch:
	dh_installexamples
override_dh_fixperms-arch:
	dh_fixperms

=== debian/watch ===
version=3
http://sf.net/cpputest/CppUTest-v(.+)\.zip

## cpputest 3.3

=== Makefile ===
--- 
+++ 
@@ -84,7 +84,7 @@
 	make CPPUTEST_USE_VPATH=Y gcov
 	make CPPUTEST_USE_VPATH=Y -f Makefile_CppUTestExt gcov
 	make CPPUTEST_USE_VPATH=Y -C examples gcov	
-	make clean
+	make clean cleanExamples
 	@echo Testing VPATH usage
 	$(TIME) make CPPUTEST_USE_VPATH=Y everythingInstall
 	make CPPUTEST_USE_VPATH=Y cleanEverythingInstall
@@ -105,16 +105,16 @@
 
 .PHONY: examples
 examples: $(TEST_TARGET) extensions
-	$(TIME) make -C examples  all CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)
+	+$(TIME) $(MAKE) -C examples  all CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)
 
 extensions: $(TEST_TARGET)
-	$(TIME) make -f Makefile_CppUTestExt all CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)
+	+$(TIME) $(MAKE) -f Makefile_CppUTestExt all CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)
 
 cleanExtensions: clean
-	$(TIME) make -f Makefile_CppUTestExt clean CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)
-	
+	+$(TIME) $(MAKE) -f Makefile_CppUTestExt clean CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)
+
 cleanExamples: clean cleanExtensions
-	$(TIME) make -C examples clean CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)
+	+$(TIME) $(MAKE) -C examples clean CPPUTEST_USE_STD_CPP_LIB=$(CPPUTEST_USE_STD_CPP_LIB) CPPUTEST_USE_REAL_GTEST=$(CPPUTEST_USE_REAL_GTEST) CPPUTEST_USE_MEM_LEAK_DETECTION=$(CPPUTEST_USE_MEM_LEAK_DETECTION)
 
 .PHONY: everythingInstall
 everythingInstall: all extensions examples

=== debian/changelog ===
cpputest (3.3-2) unstable; urgency=low

  * Upload to unstable now that wheezy is released.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 06 May 2013 10:20:24 +0200

cpputest (3.3-1) experimental; urgency=low

  * New upstream release.
  * Drop fix-ruby-shebangs.patch, merged upstream.

 -- Raphaël Hertzog <hertzog@debian.org>  Sun, 28 Apr 2013 16:40:51 +0200

cpputest (3.2-1) experimental; urgency=low

  * New upstream release.
  * Mark "build" as a PHONY target since it's a real directory in the upstream
    tarball.
  * Update watch file to point to the new GitHub location.
  * Drop fix-shebangs.patch, merged upstream.
  * Add fix-ruby-shebangs.patch to fix incorrect /bin/ruby in shebang lines of
    some scripts. 
  * Drop workaround for #676462 and increase debhelper build-dep to
    ensure we have a fixed version.

 -- Raphaël Hertzog <hertzog@debian.org>  Fri, 10 Aug 2012 09:36:54 +0200

=== debian/rules ===
--- 
+++ 
@@ -28,8 +28,5 @@
 		  debian/cpputest/usr/share/cpputest/scripts/convertToUnity/create_unity_test_runner.rb
 	dh_fixperms
 
-# Work-around debhelper bug #676462
-override_dh_installexamples-arch:
-	dh_installexamples
-override_dh_fixperms-arch:
-	dh_fixperms
+# Be explicit about "build" being a virtual target since it's a real directory
+.PHONY: build

## cpputest 3.4

=== CMakeLists.txt ===
project(CppUTest)

set(CppUTest_version_major 3)
set(CppUTest_version_minor 3)

# 2.6.3 is needed for ctest support
cmake_minimum_required(VERSION 2.6.3)

option(STD_C "Use the standard C library" ON)
option(STD_CPP "Use the standard C++ library" ON)
option(CPPUTEST_FLAGS "Use the CFLAGS/CXXFLAGS/LDFLAGS set by CppUTest" ON)
option(MEMORY_LEAK_DETECTION "Enable memory leak detection" ON)
option(EXTENSIONS "Use the CppUTest extenstion library" ON)
option(MAP_FILE "Enable the creation of a map file" OFF)
option(COVERAGE "Enable running with coverage" OFF)
option(REAL_GTEST "Enable using real GTest rather than faking it" OFF)
option(GMOCK "Enable using GMock" OFF)

option(TESTS "Compile and make tests for the code?" ON)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "What kind of build this is" FORCE)
endif(NOT CMAKE_BUILD_TYPE)

set(CppUTestRootDirectory ${PROJECT_SOURCE_DIR})

include("${CppUTestRootDirectory}/cmake/Modules/CppUTestConfigurationOptions.cmake")
include(CTest)

configure_file (
    "${PROJECT_SOURCE_DIR}/config.h.cmake"
    "${PROJECT_BINARY_DIR}/config.h"
    )
include_directories(${PROJECT_BINARY_DIR})
add_definitions(-DHAVE_CONFIG_H)

include_directories(${CppUTestRootDirectory}/include)
add_subdirectory(src/CppUTest)

if (EXTENSIONS)
    add_subdirectory(src/CppUTestExt)
endif (EXTENSIONS)

if (TESTS)
    add_subdirectory(tests)
endif (TESTS)

message("
-------------------------------------------------------
CppUTest Version ${CppUTest_version_major}.${CppUTest_version_minor}

Current compiler options:
    CC:                                 ${CMAKE_C_COMPILER}
    CXX:                                ${CMAKE_CXX_COMPILER}
    CppUTest CFLAGS:                    ${CPPUTEST_C_FLAGS}
    CppUTest CXXFLAGS:                  ${CPPUTEST_CXX_FLAGS}
    CppUTest LDFLAGS:                   ${CPPUTEST_LD_FLAGS}

Features configure in CppUTest:
    Memory Leak Detection:              ${MEMORY_LEAK_DETECTION}
    Compiling Extensions:               ${EXTENSIONS}
    Use CppUTest flags:                 ${CPPUTEST_FLAGS}

    Using Standard C library:           ${STD_C}
    Using Standard C++ library:         ${STD_CPP}

    Generating map file:                ${MAP_FILE}
    Compiling with coverage:            ${COVERAGE}

    Use 'real' GTest:                   ${REAL_GTEST}
    Able to use GMock:                  ${GMOCK}
-------------------------------------------------------
")

=== tests/CMakeLists.txt ===
enable_testing()

set(CppUTestTests_src
        AllTests.cpp
        SetPluginTest.cpp
        CheatSheetTest.cpp
        SimpleStringTest.cpp
        CommandLineArgumentsTest.cpp
        TestFailureTest.cpp
        CommandLineTestRunnerTest.cpp
        TestFilterTest.cpp
        TestHarness_cTest.cpp
        JUnitOutputTest.cpp
        TestHarness_cTestCFile.c
        MemoryLeakDetectorTest.cpp
        TestInstallerTest.cpp
        AllocLetTestFree.c
        MemoryLeakOperatorOverloadsTest.cpp
        TestMemoryAllocatorTest.cpp
        MemoryLeakWarningTest.cpp
        TestOutputTest.cpp
        AllocLetTestFreeTest.cpp
        NullTestTest.cpp
        TestRegistryTest.cpp
        AllocationInCFile.c
        PluginTest.cpp
        TestResultTest.cpp
        PreprocessorTest.cpp
        TestUTestMacro.cpp
        AllocationInCppFile.cpp
        UtestTest.cpp
)

if (MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4723")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4723")
endif (MSVC)

add_executable(CppUTestTests ${CppUTestTests_src})
target_link_libraries(CppUTestTests CppUTest)
add_test(CppUTestTests CppUTestTests)

if (TESTS)
    add_subdirectory(CppUTestExt)
endif (TESTS)

=== src/CppUTest/CMakeLists.txt ===
set(CppUTest_src
        CommandLineArguments.cpp
        MemoryLeakWarningPlugin.cpp
        TestHarness_c.cpp
        TestRegistry.cpp
        CommandLineTestRunner.cpp
        SimpleString.cpp
        TestMemoryAllocator.cpp
        TestResult.cpp
        JUnitTestOutput.cpp
        TestFailure.cpp
        TestOutput.cpp
        MemoryLeakDetector.cpp
        TestFilter.cpp
        TestPlugin.cpp
        Utest.cpp
        ../Platforms/${CPP_PLATFORM}/UtestPlatform.cpp
)

set(CppUTest_headers
        ${CppUTestRootDirectory}/include/CppUTest/CommandLineArguments.h
        ${CppUTestRootDirectory}/include/CppUTest/PlatformSpecificFunctions.h
        ${CppUTestRootDirectory}/include/CppUTest/TestMemoryAllocator.h
        ${CppUTestRootDirectory}/include/CppUTest/CommandLineTestRunner.h
        ${CppUTestRootDirectory}/include/CppUTest/PlatformSpecificFunctions_c.h
        ${CppUTestRootDirectory}/include/CppUTest/TestOutput.h
        ${CppUTestRootDirectory}/include/CppUTest/CppUTestConfig.h
        ${CppUTestRootDirectory}/include/CppUTest/SimpleString.h
        ${CppUTestRootDirectory}/include/CppUTest/TestPlugin.h
        ${CppUTestRootDirectory}/include/CppUTest/JUnitTestOutput.h
        ${CppUTestRootDirectory}/include/CppUTest/StandardCLibrary.h
        ${CppUTestRootDirectory}/include/CppUTest/TestRegistry.h
        ${CppUTestRootDirectory}/include/CppUTest/MemoryLeakDetector.h
        ${CppUTestRootDirectory}/include/CppUTest/TestFailure.h
        ${CppUTestRootDirectory}/include/CppUTest/TestResult.h
        ${CppUTestRootDirectory}/include/CppUTest/MemoryLeakDetectorMallocMacros.h
        ${CppUTestRootDirectory}/include/CppUTest/TestFilter.h
        ${CppUTestRootDirectory}/include/CppUTest/TestTestingFixture.h
        ${CppUTestRootDirectory}/include/CppUTest/MemoryLeakDetectorNewMacros.h
        ${CppUTestRootDirectory}/include/CppUTest/TestHarness.h
        ${CppUTestRootDirectory}/include/CppUTest/Utest.h
        ${CppUTestRootDirectory}/include/CppUTest/MemoryLeakWarningPlugin.h
        ${CppUTestRootDirectory}/include/CppUTest/TestHarness_c.h
        ${CppUTestRootDirectory}/include/CppUTest/UtestMacros.h
)

add_library(CppUTest STATIC ${CppUTest_src})
if (WIN32)
    target_link_libraries(CppUTest winmm.lib)
endif (WIN32)
install(FILES ${CppUTest_headers} DESTINATION include/CppUTest)
install(TARGETS CppUTest
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)

=== src/CppUTestExt/CMakeLists.txt ===
set(CppUTestExt_src
        CodeMemoryReportFormatter.cpp
        MemoryReporterPlugin.cpp
        MockFailure.cpp
        MockSupportPlugin.cpp
        GTestConvertor.cpp
        MockActualFunctionCall.cpp
        MockFunctionCall.cpp
        MockSupport_c.cpp
        MemoryReportAllocator.cpp
        MockExpectedFunctionCall.cpp
        MockNamedValue.cpp
        OrderedTest.cpp
        MemoryReportFormatter.cpp
        MockExpectedFunctionsList.cpp
        MockSupport.cpp
)

set(CppUTestExt_headers
        ${CppUTestRootDirectory}/include/CppUTestExt/MemoryReportAllocator.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockExpectedFunctionsList.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockSupportPlugin.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MemoryReportFormatter.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockFailure.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockSupport_c.h
        ${CppUTestRootDirectory}/include/CppUTestExt/GMock.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MemoryReporterPlugin.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockFunctionCall.h
        ${CppUTestRootDirectory}/include/CppUTestExt/OrderedTest.h
        ${CppUTestRootDirectory}/include/CppUTestExt/GTestConvertor.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockActualFunctionCall.h
        ${CppUTestRootDirectory}/include/CppUTestExt/MockNamedValue.h
)

add_library(CppUTestExt STATIC ${CppUTestExt_src})
target_link_libraries(CppUTestExt ${CPPUNIT_EXTERNAL_LIBRARIES})
install(FILES ${CppUTestExt_headers} DESTINATION include/CppUTestExt)
install(TARGETS CppUTestExt
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION lib
    ARCHIVE DESTINATION lib)

=== tests/CppUTestExt/CMakeLists.txt ===
set(CppUTestExtTests_src
        AllTests.cpp
        TestMockActualFunctionCall.cpp
        TestMockSupport.cpp
        TestCodeMemoryReportFormatter.cpp
        TestMockCheatSheet.cpp
        TestMockSupport_c.cpp
        TestGMock.cpp
        TestMockExpectedFunctionCall.cpp
        TestMockSupport_cCFile.c
        TestGTest.cpp
        TestMockExpectedFunctionsList.cpp
        TestMemoryReportAllocator.cpp
        TestMockFailure.cpp
        TestOrderedTest.cpp
        TestMemoryReportFormatter.cpp
        TestMemoryReporterPlugin.cpp
        TestMockPlugin.cpp
)

add_executable(CppUTestExtTests ${CppUTestExtTests_src})
target_link_libraries(CppUTestExtTests CppUTest CppUTestExt ${CPPUNIT_EXTERNAL_LIBRARIES})
add_test(CppUTestExtTests CppUTestExtTests)

=== debian/changelog ===
cpputest (3.4-3) unstable; urgency=low

  * Use -Werror in maintainer mode only. Closes: #713636
  * Use dh-autoreconf to regenerate the configure script.
  * Use --disable-silent-rules to have complete command lines in the log.

 -- Raphaël Hertzog <hertzog@debian.org>  Sat, 22 Jun 2013 22:54:59 +0200

cpputest (3.4-2) unstable; urgency=low

  * Fix homepage and watch file.
  * Update standards-version to 3.9.4.
  * Drop no longer needed dpkg-dev build dependency.

 -- Raphaël Hertzog <hertzog@debian.org>  Mon, 13 May 2013 09:23:41 +0200

cpputest (3.4-1) unstable; urgency=low

  * New upstream release.
  * Update packaging to cope with switch to autoconf.

 -- Raphaël Hertzog <hertzog@debian.org>  Sun, 12 May 2013 20:35:34 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: devel
 Priority: optional
 Maintainer: Raphaël Hertzog <hertzog@debian.org>
-Homepage: http://www.cpputest.org
+Homepage: http://cpputest.github.io/
 Vcs-Git: git://anonscm.debian.org/collab-maint/cpputest.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/cpputest.git
-Standards-Version: 3.9.3
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~)
+Standards-Version: 3.9.4
+Build-Depends: debhelper (>= 9.20120608~), dh-autoreconf
 
 Package: cpputest
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -1,19 +1,10 @@
 #!/usr/bin/make -f
 
-include /usr/share/dpkg/default.mk
+%:
+	dh $@ --with autoreconf
 
-%:
-	dh $@
-
-override_dh_auto_build:
-	$(MAKE) all extensions
-
-override_dh_auto_install:
-	mkdir -p debian/libcpputest-dev/usr/lib/$(DEB_HOST_MULTIARCH)
-	cp lib/*.a debian/libcpputest-dev/usr/lib/$(DEB_HOST_MULTIARCH)/
-
-override_dh_auto_clean:
-	$(MAKE) cleanExtensions clean
+override_dh_auto_configure:
+	dh_auto_configure -- --disable-silent-rules
 
 override_dh_compress:
 	dh_compress -X.cpp

=== debian/watch ===
version=3
opts=downloadurlmangle=s/$/?raw=true/ \
https://github.com/cpputest/cpputest.github.io/tree/master/releases \
 .*/releases/[Cc]pp[Uu][Tt]est-v?(\d.*)\.tar\.gz

## cpputest 3.7.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 project(CppUTest)
 
 set(CppUTest_version_major 3)
-set(CppUTest_version_minor 3)
+set(CppUTest_version_minor 7.1)
 
 # 2.6.3 is needed for ctest support
 cmake_minimum_required(VERSION 2.6.3)
@@ -13,16 +13,22 @@
 option(EXTENSIONS "Use the CppUTest extenstion library" ON)
 option(MAP_FILE "Enable the creation of a map file" OFF)
 option(COVERAGE "Enable running with coverage" OFF)
-option(REAL_GTEST "Enable using real GTest rather than faking it" OFF)
-option(GMOCK "Enable using GMock" OFF)
+option(C++11 "Compile with C++11 support" OFF)
 
 option(TESTS "Compile and make tests for the code?" ON)
+option(TESTS_DETAILED "Run each test separately instead of grouped?" OFF)
 
 if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "What kind of build this is" FORCE)
 endif(NOT CMAKE_BUILD_TYPE)
 
+# Pkg-config file
+include(FindPkgConfig)
+set(CppUTest_PKGCONFIG_FILE cpputest.pc)
+
 set(CppUTestRootDirectory ${PROJECT_SOURCE_DIR})
+
+set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CppUTestRootDirectory}/cmake/Modules)
 
 include("${CppUTestRootDirectory}/cmake/Modules/CppUTestConfigurationOptions.cmake")
 include(CTest)
@@ -45,6 +51,20 @@
     add_subdirectory(tests)
 endif (TESTS)
 
+# Pkg-config file.
+set (prefix "${CMAKE_INSTALL_PREFIX}")
+set (exec_prefix "${CMAKE_INSTALL_PREFIX}")
+set (libdir "${LIB_INSTALL_DIR}")
+set (includedir "${INCLUDE_INSTALL_DIR}")
+set (PACKAGE_VERSION "${CppUTest_version_major}.${CppUTest_version_minor}")
+
+configure_file (cpputest.pc.in
+    ${CMAKE_CURRENT_SOURCE_DIR}/${CppUTest_PKGCONFIG_FILE} @ONLY)
+
+install(FILES  ${CMAKE_CURRENT_SOURCE_DIR}/${CppUTest_PKGCONFIG_FILE}
+    DESTINATION ${LIB_INSTALL_DIR}/pkgconfig
+    )
+
 message("
 -------------------------------------------------------
 CppUTest Version ${CppUTest_version_major}.${CppUTest_version_minor}
@@ -63,11 +83,10 @@
 
     Using Standard C library:           ${STD_C}
     Using Standard C++ library:         ${STD_CPP}
+    Using C++11 library:                ${C++11}
 
     Generating map file:                ${MAP_FILE}
     Compiling with coverage:            ${COVERAGE}
 
-    Use 'real' GTest:                   ${REAL_GTEST}
-    Able to use GMock:                  ${GMOCK}
 -------------------------------------------------------
 ")

=== tests/CMakeLists.txt ===
enable_testing()

set(CppUTestTests_src
    AllTests.cpp
    SetPluginTest.cpp
    CheatSheetTest.cpp
    SimpleStringTest.cpp
    CommandLineArgumentsTest.cpp
    TestFailureTest.cpp
    TestFailureNaNTest.cpp
    CommandLineTestRunnerTest.cpp
    TestFilterTest.cpp
    TestHarness_cTest.cpp
    JUnitOutputTest.cpp
    TestHarness_cTestCFile.c
    MemoryLeakDetectorTest.cpp
    TestInstallerTest.cpp
    AllocLetTestFree.c
    MemoryLeakOperatorOverloadsTest.cpp
    TestMemoryAllocatorTest.cpp
    MemoryLeakWarningTest.cpp
    TestOutputTest.cpp
    AllocLetTestFreeTest.cpp
    TestRegistryTest.cpp
    AllocationInCFile.c
    PluginTest.cpp
    TestResultTest.cpp
    PreprocessorTest.cpp
    TestUTestMacro.cpp
    AllocationInCppFile.cpp
    UtestTest.cpp
    SimpleMutexTest.cpp
    UtestPlatformTest.cpp
)

if (MSVC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /wd4723")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4723")
endif (MSVC)

add_executable(CppUTestTests ${CppUTestTests_src})
target_link_libraries(CppUTestTests CppUTest)

if (TESTS)
    if (TESTS_DETAILED)
        # get all test groups and names
        execute_process(COMMAND tests/CppUTestTests -ln OUTPUT_VARIABLE CppUTestTests_GroupsAndNames)
        # convert space-separated string into a list
        separate_arguments(CppUTestTests_GroupsAndNames)
        # create separate CTest test for each CppUTestTests test
        set(lastgroup "")
        foreach(testfullname ${CppUTestTests_GroupsAndNames})
            string(REGEX MATCH "^([^/.]+)" groupname ${testfullname})
            string(REGEX MATCH "([^/.]+)$" testname ${testfullname})
            if (NOT ("${groupname}" STREQUAL "${lastgroup}"))
                message("TestGroup1: ${groupname}:")
                set(lastgroup "${groupname}")
            endif (NOT ("${groupname}" STREQUAL "${lastgroup}"))
            message("... ${testname}")
            add_test(NAME CppUTest.${testfullname} COMMAND ${EXECUTABLE_OUTPUT_PATH}/CppUTestTests -sg ${groupname} -sn ${testname} -c)
        endforeach()
    else (TESTS_DETAILED)
        # get all test groups
        execute_process(COMMAND tests/CppUTestTests -lg OUTPUT_VARIABLE CppUTestTests_Groups)
        # create separate test for each group
        separate_arguments(CppUTestTests_Groups)
        foreach(group ${CppUTestTests_Groups})
            message("TestGroup1: ${group}")
            add_test(NAME CppUTest.${group} COMMAND ${EXECUTABLE_OUTPUT_PATH}/CppUTestTests -sg ${group} -c)
        endforeach()
    endif (TESTS_DETAILED)

    add_subdirectory(CppUTestExt)
endif (TESTS)

=== src/CppUTest/CMakeLists.txt ===
--- 
+++ 
@@ -13,6 +13,7 @@
         MemoryLeakDetector.cpp
         TestFilter.cpp
         TestPlugin.cpp
+        SimpleMutex.cpp
         Utest.cpp
         ../Platforms/${CPP_PLATFORM}/UtestPlatform.cpp
 )

=== tests/CppUTestExt/CMakeLists.txt ===
set(CppUTestExtTests_src
    AllTests.cpp
    CodeMemoryReportFormatterTest.cpp
    GMockTest.cpp
    GTest1Test.cpp
    MemoryReportAllocatorTest.cpp
    MemoryReporterPluginTest.cpp
    MemoryReportFormatterTest.cpp
    MockActualCallTest.cpp
    MockCheatSheetTest.cpp
    MockExpectedCallTest.cpp
    MockExpectedFunctionsListTest.cpp
    MockFailureTest.cpp
    MockPluginTest.cpp
    MockSupportTest.cpp
    MockSupport_cTestCFile.c
    MockSupport_cTest.cpp
    OrderedTestTest.cpp
)

add_executable(CppUTestExtTests ${CppUTestExtTests_src})
target_link_libraries(CppUTestExtTests CppUTest CppUTestExt ${CPPUNIT_EXTERNAL_LIBRARIES})

if (TESTS)
    # get all test groups
    execute_process(COMMAND tests/CppUTestExt/CppUTestExtTests -lg OUTPUT_VARIABLE CppUTestTestsExt_Groups)
    # create separate test for each group
    separate_arguments(CppUTestTestsExt_Groups)
    foreach(group ${CppUTestTestsExt_Groups})
        message("TestGroup2: ${group}:")
        add_test(NAME CppUTestExt.${group} COMMAND ${EXECUTABLE_OUTPUT_PATH}/CppUTestExtTests -sg ${group} -c)
    endforeach()
endif (TESTS)

=== debian/changelog ===
cpputest (3.7.1-1) unstable; urgency=medium

  * New upstream release.
  * Drop debian/patches/werror-in-maint-mode-only.patch, merged upstream.
  * Improve watch file to skip X.Ydev tarballs.
  * Update Vcs-Browser to point to new cgit urls.
  * Update Standards-Version to 3.9.6, no change.

 -- Raphaël Hertzog <hertzog@debian.org>  Thu, 07 May 2015 10:34:28 +0200
